"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/pagination.js
var pagination_exports = {};
__export(pagination_exports, {
  TablePaginationActions: () => TablePaginationActions,
  default: () => pagination_default
});
module.exports = __toCommonJS(pagination_exports);
var import_react2 = __toESM(require("react"), 1);
var import_icons_material2 = require("@mui/icons-material");
var import_material2 = require("@mui/material");
var import_constants2 = require("@northern.tech/store/constants");
var import_debouncehook2 = require("@northern.tech/utils/debouncehook");

// src/mendertooltip.js
var import_react = __toESM(require("react"), 1);
var import_icons_material = require("@mui/icons-material");
var import_material = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_constants = require("@northern.tech/store/constants");
var import_debouncehook = require("@northern.tech/utils/debouncehook");
var import_helpers = require("@northern.tech/utils/helpers");
var import_jsx_runtime = require("react/jsx-runtime");
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  icon: {
    "&.read": {
      color: theme.palette.text.disabled
    }
  },
  iconAura: {
    position: "absolute",
    top: -5,
    bottom: 0,
    left: -5,
    right: -5,
    border: `1px dashed ${theme.palette.primary.main}`,
    borderRadius: "50%",
    "&.read": {
      borderColor: theme.palette.text.disabled
    }
  }
}));
var MenderTooltip = (0, import_mui.withStyles)(import_material.Tooltip, ({ palette, shadows, spacing }) => ({
  arrow: {
    color: palette.background.paper
  },
  tooltip: {
    backgroundColor: palette.background.paper,
    boxShadow: shadows[1],
    color: palette.text.primary,
    padding: spacing(2),
    fontSize: "small",
    maxWidth: 600,
    info: {
      maxWidth: 300,
      color: palette.text.hint,
      backgroundColor: palette.grey[500]
    }
  }
}));
var iconWidth = 30;
var OnboardingTooltip = (0, import_mui.withStyles)(import_material.Tooltip, (theme) => ({
  arrow: {
    color: theme.palette.primary.main
  },
  tooltip: {
    backgroundColor: theme.palette.primary.main,
    boxShadow: theme.shadows[1],
    color: theme.palette.grey[500],
    fontSize: 14,
    maxWidth: 350,
    padding: "12px 18px",
    width: 350,
    "& a": {
      color: theme.palette.grey[500]
    },
    "&.MuiTooltip-tooltipPlacementTop": { marginLeft: iconWidth, marginBottom: 0, marginTop: `calc(${iconWidth} + ${theme.spacing(1.5)})` },
    "&.MuiTooltip-tooltipPlacementRight": { marginTop: iconWidth / 2 },
    "&.MuiTooltip-tooltipPlacementBottom": { marginLeft: iconWidth },
    "&.MuiTooltip-tooltipPlacementLeft": { marginTop: iconWidth / 2 }
  },
  popper: {
    opacity: 0.9
  }
}));
var mendertooltip_default = MenderTooltip;
var tooltipStateStyleMap = {
  [import_constants.READ_STATES.read]: "read muted",
  default: ""
};

// src/pagination.js
var import_jsx_runtime2 = require("react/jsx-runtime");
var defaultRowsPerPageOptions = [10, 20, import_constants2.DEVICE_LIST_MAXIMUM_LENGTH];
var { perPage: defaultPerPage } = import_constants2.DEVICE_LIST_DEFAULTS;
var paginationIndex = 1;
var paginationLimit = 1e4;
var MaybeWrapper = ({ children, disabled }) => disabled ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(mendertooltip_default, { arrow: true, placement: "top", title: "Please refine your filter criteria first in order to proceed.", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children }) }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children });
var TablePaginationActions = ({ count, page = 0, onPageChange, rowsPerPage = defaultPerPage, showCountInfo = true }) => {
  const [pageNo, setPageNo] = (0, import_react2.useState)(page + paginationIndex);
  (0, import_react2.useEffect)(() => {
    setPageNo(page + paginationIndex);
  }, [page, rowsPerPage, count]);
  const debouncedPage = (0, import_debouncehook2.useDebounce)(pageNo, import_constants2.TIMEOUTS.debounceShort);
  (0, import_react2.useEffect)(() => {
    const newPage = Math.min(Math.max(paginationIndex, debouncedPage), Math.max(paginationIndex, Math.ceil(count / rowsPerPage)));
    if (newPage !== page + paginationIndex) {
      onPageChange(newPage);
    }
  }, [count, debouncedPage, onPageChange, page, rowsPerPage]);
  const pages = Math.ceil(count / rowsPerPage);
  const isAtPaginationLimit = pageNo >= paginationLimit / rowsPerPage;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "flexbox center-aligned", children: [
    showCountInfo && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: `${(pageNo - paginationIndex) * rowsPerPage + 1}-${Math.min(pageNo * rowsPerPage, count)} of ${count}` }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_material2.IconButton, { onClick: () => setPageNo(pageNo - 1), disabled: pageNo === paginationIndex, size: "large", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_icons_material2.KeyboardArrowLeft, {}) }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(MaybeWrapper, { disabled: isAtPaginationLimit, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_material2.IconButton, { onClick: () => setPageNo(pageNo + 1), disabled: pageNo >= pages || isAtPaginationLimit, size: "large", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_icons_material2.KeyboardArrowRight, {}) }) })
  ] });
};
var Pagination = (props) => {
  const { className, onChangeRowsPerPage, onChangePage, page = 0, rowsPerPageOptions = defaultRowsPerPageOptions, showCountInfo, ...remainingProps } = props;
  const propsPage = Math.max(page - paginationIndex, 0);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    import_material2.TablePagination,
    {
      className: `flexbox margin-top ${className || ""}`,
      classes: { spacer: "flexbox no-basis" },
      component: "div",
      labelDisplayedRows: () => "",
      labelRowsPerPage: "Rows",
      SelectProps: { name: "pagination" },
      rowsPerPageOptions,
      onRowsPerPageChange: (e) => onChangeRowsPerPage(e.target.value),
      page: propsPage,
      onPageChange: onChangePage,
      ActionsComponent: (actionProps) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(TablePaginationActions, { ...actionProps, showCountInfo }),
      ...remainingProps
    }
  );
};
var pagination_default = Pagination;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TablePaginationActions
});
//# sourceMappingURL=pagination.cjs.map